if not FuBar then return end

setfenv(1, MicroMenu.fenv)

--[[-----------------------------------------------------------------------------
Local to module
-------------------------------------------------------------------------------]]
local _OnEnter, _OnLeave, _RefreshDisplay, _StartMoving, _StopMoving = Button_OnEnter, Button_OnLeave, RefreshDisplay, frame.StartMoving, frame.StopMovingOrSizing

local function FuBar_RefreshButtonSize()
	if settings then
		RefreshButtonSize()
	end
end

--[[-----------------------------------------------------------------------------
Global to addon
-------------------------------------------------------------------------------]]
Button_OnEnter = function(self, motion)
	FuBar:Panel_OnEnter(addon)
	_OnEnter(self, motion)
end

Button_OnLeave = function(self, motion)
	if not (Dewdrop:IsOpen(frame) or skipLeave) then
		FuBar:Panel_OnLeave(addon)
	end
	_OnLeave(self, motion)
end

GetButtonSize = function()
	return FuBar:GetFontSize()
end

GetButtonMaxSize = function()
	return FuBar:GetFontSize() + FuBar:GetThickness()
end

RefreshDisplay = function()
	_RefreshDisplay()
	if addon.panel and addon.panel:GetPluginSide(addon) == 'CENTER' then
		addon.panel:UpdateCenteredPosition()
	end
end

--[[-----------------------------------------------------------------------------
Global
-------------------------------------------------------------------------------]]
addon.cannotAttachToMinimap = true
addon.cannotDetachTooltip = true
addon.defaultPosition = 'LEFT'
addon.hasIcon = false
addon.hasNoColor = true
addon.hasNoText = true
addon.hideWithoutStandby = true
addon.independentProfile = true
addon.overrideMenu = true
addon.overrideTooltip = true

addon.CheckWidth = FuBar_RefreshButtonSize
addon.SetFontSize = FuBar_RefreshButtonSize

--[[-----------------------------------------------------------------------------
Initialize module
-------------------------------------------------------------------------------]]
frame:SetScript('OnEnter', Button_OnEnter)
frame:SetScript('OnLeave', Button_OnLeave)
for _, button in pairs(buttons) do
	button:SetScript('OnEnter', Button_OnEnter)
	button:SetScript('OnLeave', Button_OnLeave)
end

local isMoving, oldX, oldY
frame.StartMoving = function(...)
	isMoving, oldX, oldY = true, frame:GetCenter()
	_StartMoving(...)
end

frame.StopMovingOrSizing = function(...)
	if isMoving then
		local maxClickDistance, x, y = settings and settings.sensitivity or frame:GetHeight() / 2, frame:GetCenter()
		if abs(oldX - x) > maxClickDistance or abs(oldY - y) > maxClickDistance then
			skipClick = true
		end
		isMoving = nil
	end
	_StopMoving(...)
end
